<template>
  <div
    :class="alertRootClass"
    class="break-all rounded-md p-4"
  >
    <div
      :class="alertBodyClass"
      class="flex"
    >
      <div class="flex flex-shrink-0 items-center">
        <component
          :is="icon"
          class="h-5 w-5 fill-current"
        />
      </div>
      <div class="ml-3 flex-1 text-sm md:flex md:justify-between">
        <slot />
      </div>
    </div>
  </div>
</template>

<script lang="ts" setup>
import type { FunctionalComponent, SVGAttributes } from "vue";

const props = defineProps<{
  icon: FunctionalComponent<SVGAttributes>;
  type: "info" | "success" | "warning" | "error";
}>();

const alertRootClass = computed(() => ({
  "bg-blue-50": props.type === "info",
  "bg-green-50": props.type === "success",
  "bg-yellow-50": props.type === "warning",
  "bg-red-50": props.type === "error",
}));

const alertBodyClass = computed(() => ({
  "text-blue-700": props.type === "info",
  "text-green-700": props.type === "success",
  "text-yellow-700": props.type === "warning",
  "text-red-700": props.type === "error",
}));
</script>
